NON_VOLATILE    equ     01h     ; 01=NV, 00=Volatile

CMD_SET_MAX_EX equ     37h
;--------------------------------------------
;       SetMaxAddress48(37h,out)
;--------------------------------------------
SetMaxAddress48 PROC   near
                mov     dx,offset start_max48bit
                call    _puts
SetMaxAddress48_reent:
                cli     ; 荞݋֎~ 

                mov     al,11100000b    ; select LBA
                or      al,SlaveBit
                mov     dx,IDEreg_SDHead
                out     dx,al
                wait1u
;previous
                mov     dx,IDEreg_LBAHigh ; (64Ah)LBA bit40-47
                mov     al,Data5
                out     dx,al
                wait1u

                mov     dx,IDEreg_LBAMid ; (648h)LBA bit32-39
                mov     al,Data4
                out     dx,al
                wait1u

                mov     dx,IDEreg_LBALow  ; (646h)LBA bit24-31
                mov     al,Data3
                out     dx,al
                wait1u

; 2nd
                mov     dx,IDEreg_LBAHigh ; (64Ah)LBA bit16-23
                mov     al,Data2
                out     dx,al
                wait1u

                mov     dx,IDEreg_LBAMid  ; (648h)LBA bit8-15
                mov     al,Data1
                out     dx,al
                wait1u

                mov     dx,IDEreg_LBALow  ; (646h)LBA bit0-7
                mov     al,Data0
                out     dx,al
                wait1u

                mov     dx,IDEreg_SCount ; (0644h)
                mov     al,NON_VOLATILE
                out     dx,al
                wait1u
if 0
                mov     dx,IDEreg_Feature ; (0642h)   ; OUT
                mov     al,0
                out     dx,al
                wait1u
endif
                mov     dx,IDEreg_Command  ;(064Eh)
                mov     al,37h     ;CMD_SET_MAX_EX 
                out     dx,al
                call    wait01s
                sti     ; 荞݋֎~

                call    Wait_ERR_BSY ;  Xe[^XEɍs
                jc      SetMax48Fail

                mov     eax,DataLongL
                mov     AddrNativeMax48,eax
                mov     edx,DataLongH
                mov     AddrNativeMax48H,edx
                call    DisplayCapacity

                clc
                ret
SetMax48Fail:
                inc     cs:ErrCount
                cmp     cs:ErrCount,3
                ja      @f
                jmp     SetMaxAddress48_reent
        @@:
                stc
                ret
SetMaxAddress48 ENDP


;--------------------------------------------
;       ReadNativeMax48 
;--------------------------------------------
CMD_READ_MAX_EX equ     027h
ReadNativeMax48 PROC   near

ReadNativeMax48_reent:
                xor     eax,eax
                mov     DataLongL,eax
                mov     DataLongH,eax
                pushf
                cli     ; 荞݋֎~ 
                mov     al,01000000b    ; SDH register  LBA bit=1
                or      al,SlaveBit
                mov     dx,IDEreg_SDHead ; (064C)
                out     dx,al
                wait1u
                mov     dx,IDEreg_Command  ;(064Eh)
                mov     al,CMD_READ_MAX_EX
                out     dx,al
                wait1u
                popf     ; 荞݋֎~

                call    Wait_ERR_BSY ;  Xe[^XEɍs
                jc      ReadNativeMax48Fail     ; G[Ȃ玸s

                mov     dx,IDEreg_DevCtrl
                mov     al,F_nIEN
                out     dx,al

                mov     dx,IDEreg_LBALow
                in      al,dx   ; 8bit read
                mov     Data0,al
                
                mov     dx,IDEreg_LBAMid
                in      al,dx   ; 8bit read
                mov     Data1,al
                
                mov     dx,IDEreg_LBAHigh
                in      al,dx   ; 8bit read
                mov     Data2,al

                mov     al,01000000b    ; SDH register  LBA bit=1
                or      al,SlaveBit
                cli     ; 荞݋֎~ 
                mov     dx,IDEreg_SDHead ; (064C)
                out     dx,al
                wait1u

                mov     dx,IDEreg_Command  ;(064Eh)
                mov     al,CMD_READ_MAX_EX
                out     dx,al
                wait1u
                sti     ; 荞݋֎~
                call    Wait_ERR_BSY ;  Xe[^XEɍs
                jc      ReadNativeMax48Fail

                mov     dx,IDEreg_DevCtrl       ;IDEreg_Doutput
                mov     al,F_nIEN+F_HOB1
                out     dx,al

                mov     dx,IDEreg_LBALow
                in      al,dx   ; 8bit read
                mov     Data3,al
                
                mov     dx,IDEreg_LBAMid
                in      al,dx   ; 8bit read
                mov     Data4,al
                
                mov     dx,IDEreg_LBAHigh
                in      al,dx   ; 8bit read
                mov     Data5,al
                mov     edx,DataLongH
                mov     eax,DataLongL
                mov     AddrNativeMax48,eax
                mov     AddrNativeMax48H,edx

                mov     dx,offset msg_nat_48b
                call    _puts
                mov     eax,DataLongH
                call    digitlx2
                mov     eax,DataLongL
                call    digitlx
                mov     dx,offset msg_TCAPA
                call    _puts

                mov     edx,DataLongH
                shl     edx,11
                mov     eax,DataLongL
                inc     eax
                adc     edx,0
                shr     eax,21
                or      eax,edx
                call    digitl
                mov     dx,offset msg_GiB
                call    _puts
                mov     dx,offset msg_CRLF
                call    _puts

                clc
                ret
ReadNativeMax48Fail:
                inc     cs:ErrCount
                cmp     cs:ErrCount,10
                ja      @f
                jmp     ReadNativeMax48_reent
        @@:
                stc
                ret
ReadNativeMax48 ENDP

;--------------------------------------------
;       SetMaxAddress (28bit, command F9)
;--------------------------------------------
SetMaxAddress   PROC   near     ; DataLongL
                mov     dx,offset start_max28bit
                call    _puts
SetMaxAddress_reent:
                cli     ; 荞݋֎~ 

                mov     dx,IDEreg_SDHead ; (064Ch)
                mov     al,Data3        ; LBA bit 24-27
                or      al,01000000b    ; LBA flag bit
                out     dx,al

                mov     dx,IDEreg_LBAHigh ; (64Ah)LBA bit16-23
                mov     al,Data2
                out     dx,al

                mov     dx,IDEreg_LBAMid ; (648h)LBA bit8-15
                mov     al,Data1
                out     dx,al
                wait1u

                mov     dx,IDEreg_LBALow  ; (646h)LBA bit0-7
                mov     al,Data0
                out     dx,al
                wait1u

                mov     dx,IDEreg_SCount ; (0644h)
                mov     al,NON_VOLATILE
                out     dx,al
                wait1u

                mov     dx,IDEreg_Feature ; (0642h)   ; OUT
                mov     al,0
                out     dx,al
                wait1u

                mov     dx,IDEreg_Command  ;(064Eh)
                mov     al,0F9h
                out     dx,al
                call    wait01s
                sti     ; 荞݋֎~
                call    Wait_ERR_BSY ;  Xe[^XEɍs
                jc      SetMax28Fail

                xor     edx,edx
                mov     eax,DataLongL
                inc     eax
                call    DisplayCapacity
                clc
                ret
SetMax28Fail:
                inc     cs:ErrCount
                cmp     cs:ErrCount,3
                ja      @f
                jmp     SetMaxAddress_reent
        @@:
                stc
                ret
SetMaxAddress   ENDP

;--------------------------------------------
;       ReadNativeMax(F8,in)
;--------------------------------------------
ReadNativeMax   PROC   near
ReadNativeMax_reent:
                xor     eax,eax
                mov     DataLongL,eax
ReadNativeMax28Entry:
                mov     al,01000000b    ; SDH register  LBA bit=1
                or      al,SlaveBit
                mov     dx,IDEreg_SDHead ; (064C)
                pushf
                cli     ; 荞݋֎~ 
                out     dx,al
                wait1u
                mov     dx,IDEreg_Command  ;(064Eh)
                mov     al,0F8h         ; ReadNativeMax(28bit)
                out     dx,al
                wait1u
                popf    ; 荞݋֎~

                call    Wait_ERR_BSY ;  Xe[^XEɍs
                jc      ReadNativeMax28Fail     ; G[Ȃ玸s

                mov     dx,IDEreg_LBALow
                in      al,dx   ; 8bit read     ; lower byte
                mov     Data0,al
                mov     dx,IDEreg_LBAMid
                in      al,dx   ; 8bit read
                mov     Data1,al
                mov     dx,IDEreg_LBAHigh
                in      al,dx   ; 8bit read
                mov     Data2,al
                mov     dx,IDEreg_SDHead        ; bit 24-27 last 4bit
                in      al,dx   ; 8bit read
                and     al,00001111b
                mov     Data3,al

                mov     dx,offset msg_nat_28b
                call    _puts
                mov     eax,DataLongL
                mov     AddrNativeMax28,eax
                call    DisplayCapacity
                clc
                ret
ReadNativeMax28Fail:
                inc     cs:ErrCount
                cmp     cs:ErrCount,5
                ja      @f
                jmp     ReadNativeMax_reent
        @@:
                stc
                ret
ReadNativeMax   ENDP

;--------------------------------------------
;       SetMaxAddressCHS
;--------------------------------------------
SetMaxAddressCHS   PROC   near     ; DataLongL
                mov     dx,offset start_max_CHS
                call    _puts

                cli     ; 荞݋֎~ 
if 1
                mov     dx,IDEreg_Feature ; (0642h)   ; OUT
                mov     al,0
                out     dx,al
                wait1u
endif
                mov     dx,IDEreg_SecNum  ; (646h)
                mov     al,3Fh            ;Data0 
                out     dx,al
                wait1u

                mov     dx,IDEreg_CylLow ; (648h)
                mov     al, 0FFh        ;Data1
                out     dx,al
                wait1u

                mov     dx,IDEreg_CylHigh ; (64Ah)
                mov     al, 3Fh        ;Data2
                out     dx,al
                wait1u

                mov     dx,IDEreg_SDHead ; (064Ch)
                mov     al, 10h;            Data3=16
                or      al,10100000b
                or      al,SlaveBit
                out     dx,al
                wait1u

                mov     dx,IDEreg_SCount ; (0644h)
                mov     al,NON_VOLATILE
                out     dx,al
                wait1u
                wait1u

                mov     dx,IDEreg_Command  ;(064Eh)
                mov     al,0F9h
                out     dx,al
                call    wait01s
                sti     ; 荞݋֎~
                call    Wait_ERR_BSY ;  Xe[^XEɍs
                jc      SetMaxChsFail

;                call    DisplayCapacity
                clc
                ret
SetMaxChsFail:
                mov     eax,DataLongL
                call    DisplayCapacity
                stc
                ret
SetMaxAddressCHS   ENDP

